#!/usr/bin/python  

# Using ethernet to talk to an Agilent Infiniium MSO9404A  
# See also the "Infiniium 9000A Programmer's Reference"  

import socket
import sys
import datetime
import smtplib

f = open("regA.txt", "r")
regA = str(f.read(4))
f.close()
f = open("regB.txt", "r") 
regB = str(f.read(4))
f.close()
f = open("boardNum.txt", "r") 
boardNum = str(f.read(1))
f.close()

if boardNum == "0":
	sys.exit()

sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
sock.settimeout(10)
try:
	sock.connect(("192.168.0.102", 5025))
except:
	print "No tohle nevyslo..."
        server = smtplib.SMTP('smtp.gmail.com', 587)
        server.starttls()
        server.login("user", "pass")
 
        msg = "Subject: rpi@CESNET Osciloscope down\nWhat to do?\nRestart Infiinium app\nWait until right time\nRun python reset.py\nChange boardNum to the right value"
        server.sendmail("sender@gmail.com", "addressee@fit.cvut.cz", msg)
        server.quit()
	f = open("boardNum.txt", "w") 
	f.write('0')
	sys.exit()


def cmd(s):
    sock.send(s + "\n")


def resp():
    r = sock.recv(1048576)
    while not r.endswith("\n"):
        r += sock.recv(1048576)
    return r


print "Querying scope"

try:
	cmd("*IDN?")
except:
	server = smtplib.SMTP('smtp.gmail.com', 587)
	server.starttls()
	server.login("tom.preucil@gmail.com", "#x2nFI=1G#KE")
 
	msg = "Subject: Machale, spadlo ti to\nMessage body"
	server.sendmail("tom.preucil@gmail.com", "preucto2@fit.cvut.cz", msg)
	server.quit()

print "Scope identifies as: ", resp(),

# This should block until the capture is done, since we used :digitize
cmd(":MEASure:RESults?")

sample_string = resp().rstrip().rstrip(",")
ascii_samples = sample_string.split(",")

samples = []
i = 1
for f in ascii_samples:
#    try:
	if i % 7 != 1:
       		samples.append(float(f))
	else:
		samples.append(f)
	i = i + 1

	if i == 29:
		break
#    except:
#        print "Couldn't convert:", f

#print "Got ", len(samples), " samples. Values 1-10:", samples[:2000]  
print samples

freq = open("frequency.csv", "a")
freq.write(str(datetime.datetime.now()))
freq.write(',')
freq.write(regA)
freq.write(',')
freq.write(regB)
freq.write(',')
freq.write(boardNum)
freq.write(',')
freq.write(str(samples[1]))
freq.write(',')
freq.write(str(samples[2]))
freq.write(',')
freq.write(str(samples[3]))
freq.write(',')
freq.write(str(samples[4]))
freq.write(',')
freq.write(str(samples[5]))
freq.write(',')
freq.write(str(samples[6]))
freq.write('\n')

rise = open("rise.csv", "a")
rise.write(str(datetime.datetime.now()))
rise.write(',')
rise.write(regA)
rise.write(',')
rise.write(regB)
rise.write(',')
rise.write(boardNum)
rise.write(',')
rise.write(str(samples[8]))
rise.write(',')
rise.write(str(samples[9]))
rise.write(',')
rise.write(str(samples[10]))
rise.write(',')
rise.write(str(samples[11]))
rise.write(',')
rise.write(str(samples[12]))
rise.write(',')
rise.write(str(samples[13]))
rise.write('\n')

fall = open("fall.csv", "a")
fall.write(str(datetime.datetime.now()))
fall.write(',')
fall.write(regA)
fall.write(',')
fall.write(regB)
fall.write(',')
fall.write(boardNum)
fall.write(',')
fall.write(str(samples[15]))
fall.write(',')
fall.write(str(samples[16]))
fall.write(',')
fall.write(str(samples[17]))
fall.write(',')
fall.write(str(samples[18]))
fall.write(',')
fall.write(str(samples[19]))
fall.write(',')
fall.write(str(samples[20]))
fall.write('\n')

duty = open("duty.csv", "a")
duty.write(str(datetime.datetime.now()))
duty.write(',')
duty.write(regA)
duty.write(',')
duty.write(regB)
duty.write(',')
duty.write(boardNum)
duty.write(',')
duty.write(str(samples[22]))
duty.write(',')
duty.write(str(samples[23]))
duty.write(',')
duty.write(str(samples[24]))
duty.write(',')
duty.write(str(samples[25]))
duty.write(',')
duty.write(str(samples[26]))
duty.write(',')
duty.write(str(samples[27]))
duty.write('\n')

freq.close()
rise.close()
fall.close()
duty.close()
